Add license comment headers to builds (ignore version number inclusion)

Plan future deprecations, like helper system (replace with `var h = require('myhelper') ?`, layout `fs` usage?
Reformat helpers code style (esp layout)
Reformat runtime code style
Add debug statements to layout helpers



Most Important Things:

Refactor Tests:
  - rather than specific tests, run a big gamut of HTML, or programatically generate all possible combinations of features and whitespace
  - Tests need to at least be separate files
  - Minimize new file overhead: use ENV vars, include small util file (contexts, vm, etc)
  - Possibly switch from vows (too much boilerplate) to anything else

Convert to CJS

Remove auto-build num stuff


Try Out Gulp
============



Convert to CJS
==============

Goals
-----

- Consume via global
  - `<script src="vash.js"></script>`
  - `<script src="vash-runtime.js"></script>`
- Consume via Browserify
  - `require('vash')`
  - `require('vash-runtime')`
- Consume via RequireJS
  - `define(['vash'], function(vash) {})`
  - `define(['vash-runtime'], function(vashrun) {})`
- Consume via Bower? Perhaps rely on plugin for this.
- Simplify build system

Definitely
----------

- [ ] index.js requires everything
- [ ] src/vexports.js -> src/compile.js, src/config.js
- [ ] rename src/* to not be prefixed with v
- [ ] compiled template cannot rely on vash / vash.helpers global
- [ ] linking cannot rely on global vash
- [ ] bundling via browserify
- [ ] supports/exports.{head,tail}.js removed
- [ ] vash version number is included in standalone builds
- [ ] split runtime into separate files in src/runtime

Maybe
-----

- [ ] runtime as global is not `vash`, instead is `vashrun`
- [ ] runtime does not include UMD guard
- [ ] runtime as separate package
- [ ] vash.pkg ~= readFile('package.json')
- [ ] Helpers are registered instead of attaching to global: `require('my-helpers')(vash)` or `vash.helper(require('my-helpers'))`
- [ ] src/api.js is public exports